#include "StdAfx.h"
#include "Form1.h"

using namespace EncapsTest;
#define N_FADERS 4
System::Void Form1::Form1_Load(System::Object^  sender, System::EventArgs^  e)
{
   Faders = gcnew array<Fader^> (N_FADERS);
/*	array<Fader::dgFader^>^ dgFaders = 
      {gcnew Fader::dgFader(this, &Form1::FaderEqValueChanged),
      gcnew Fader::dgFader(this, &Form1::Fader_numericUpDown1_ValueChanged),
      gcnew Fader::dgFader(this, &Form1::Fader_numericUpDown2_ValueChanged),
      gcnew Fader::dgFader(this, &Form1::Fader_checkBox1_CheckedChanged),
      gcnew Fader::dgFader(this, &Form1::Fader_button1_Click),
      gcnew Fader::dgFader(this, &Form1::Fader_button2_Click)};
*/
   for (int i = 0;i<N_FADERS;i++)
   {
      Faders[i] = gcnew Fader(i); 
      tabPage1->Controls->Add(Faders[i]);

      if(i==0)
         Faders[0]->Left = 3;
      else
         Faders[i]->Left = Faders[i-1]->Right+3;
      Faders[i]->Top = 3;
      // could probably put these in array but like this is actually easier
      Faders[i]->dgEqValueChanged = gcnew Fader::dgFader(this, &Form1::FaderEqValueChanged);
      Faders[i]->dgNumericUpDown1_ValueChanged = gcnew Fader::dgFader(this, &Form1::Fader_numericUpDown1_ValueChanged);
      Faders[i]->dgNumericUpDown2_ValueChanged = gcnew Fader::dgFader(this, &Form1::Fader_numericUpDown2_ValueChanged);
      Faders[i]->dgCheckBox1_CheckedChanged = gcnew Fader::dgFader(this, &Form1::Fader_checkBox1_CheckedChanged);
      Faders[i]->dgButton1_Click = gcnew Fader::dgFader(this, &Form1::Fader_button1_Click);
      Faders[i]->dgButton2_Click = gcnew Fader::dgFader(this, &Form1::Fader_button2_Click);
   }
}
System::Void Form1::FaderEqValueChanged(int FaderID)
{
   textBox1->Text = String::Format("TrackBar{0}",FaderID+1);
   textBox2->Text = String::Format("Value = {0}",Faders[FaderID]->EqValue);  // access by property here
}
System::Void Form1::Fader_numericUpDown1_ValueChanged(int FaderID)
{
   textBox1->Text = String::Format("UpDownHi{0}",FaderID+1);
   textBox2->Text = String::Format("Value = {0}",Faders[FaderID]->numericUpDown1->Value); // crude but quick - class component declared public
}
System::Void Form1::Fader_numericUpDown2_ValueChanged(int FaderID)
{
   textBox1->Text = String::Format("UpDownLow{0}",FaderID+1);
   textBox2->Text = String::Format("Value = {0}",Faders[FaderID]->numericUpDown2->Value);
}
System::Void Form1::Fader_checkBox1_CheckedChanged(int FaderID)
{
   textBox1->Text = String::Format("CheckBox{0}",FaderID+1);
   textBox2->Text = String::Format("Checked = {0}",Faders[FaderID]->checkBox1->Checked);
}
System::Void Form1::Fader_button1_Click(int FaderID)
{
   textBox1->Text = String::Format("Button X {0}",FaderID);
   textBox2->Text = String::Format("Clicked X @ {0}",FaderID);
}
System::Void Form1::Fader_button2_Click(int FaderID)
{
   textBox1->Text = String::Format("Button Y {0}",FaderID);
   textBox2->Text = String::Format("Clicked Y @ {0}",FaderID);
}
System::Void Form1::button1_Click(System::Object^  sender, System::EventArgs^  e) // send data to class
{
   int i = (int)numericUpDown1->Value;
   Faders[i]->Anno = textBox3->Text;
}
